program project1;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes,
  EpikTimer,SysUtils
  { you can add units after this };

Procedure SpeedTestLoop;
var i,i2:PtrUInt;
  Timer:TEpikTimer;
label j1;
  {$OPTIMIZATION ON}
begin
  Timer:=TEpikTimer.Create(nil);
  Timer.Clear;  Timer.Start;
  i:=100000000;
  {$IFDEF CPU32}
  asm
        mov i,%eax
  j1:  DEC  %eax
        JNZ  j1
  end;
  {$ENDIF}
  {$IFDEF CPU64}
  asm
        mov i,%rax
  j1:  DEC  %rax
        JNZ  j1
  end;
  {$ENDIF}

  Timer.Stop;
  Writeln('asm '+FloatToStr(Timer.Elapsed)+' sec');

  Timer.Clear;  Timer.Start;
  for i:=100000000 downto 0 do
    Asm Nop end;
  Timer.Stop;
  Writeln('for downto '+FloatToStr(Timer.Elapsed)+' sec');

  Timer.Clear;  Timer.Start;
    for i:=1 to 100000000 do
        Inc(i2);
  Timer.Stop;
  Writeln('for to '+FloatToStr(Timer.Elapsed)+' sec');

  Timer.Clear;  Timer.Start;
  i:=1;
  repeat
    Inc(i);
  until i>100000000;
  Timer.Stop;
  Writeln('repeat '+FloatToStr(Timer.Elapsed)+' sec');

  Timer.Clear;  Timer.Start;
  i:=1;
  while i<100000000 do
    Inc(i);
  Timer.Stop;
  Writeln('while '+FloatToStr(Timer.Elapsed)+' sec');

end;
{

Intel(R) Core(TM) i5-2500K CPU @ 3.30GHz
Sandy Bridge-DT XE
Microsoft Windows XP Professional x64 Edition Build 3790
Free Pascal Compiler version 2.7.1 [2012/08/25] for x86_64
Result:

asm 0.0256358138703286 sec
for downto 0.193564002384441 sec
for to 0.177300077002942 sec
repeat 0.158137833298043 sec
while 0.156996773175159 sec

Intel(R) Core(TM)2 CPU 6600  @ 2.40GHz
Linux x86
Free Pascal Compiler version 2.7.1 [2012/11/17] for i386
Result:

asm 0.049642 sec
for downto 0.322694 sec
for to 0.312163 sec
repeat 0.298781 sec
while 0.298575 sec

}
begin
  SpeedTestLoop;
end.
